package se.festivitas.gwtptest.client.place;

import com.gwtplatform.mvp.client.proxy.PlaceManagerImpl;
import com.gwtplatform.mvp.client.proxy.PlaceRequest;
import com.gwtplatform.mvp.client.proxy.RevealRootPopupContentEvent;

import se.festivitas.gwtptest.client.events.showMainPage;
import se.festivitas.gwtptest.client.place.DefaultPlace;
import se.festivitas.gwtptest.client.presenter.LoginPopupPresenter;

import com.google.inject.Inject;
import com.google.gwt.event.shared.EventBus;
import com.gwtplatform.mvp.client.proxy.TokenFormatter;

public class ClientPlaceManager extends PlaceManagerImpl {

	private final PlaceRequest defaultPlaceRequest;
	
	LoginPopupPresenter loginPopupPresenter;

	@Inject
	public ClientPlaceManager(final EventBus eventBus,
			final TokenFormatter tokenFormatter,
			LoginPopupPresenter loginPopupPresenter,
			@DefaultPlace final String defaultPlaceNameToken) {
		super(eventBus, tokenFormatter);
		this.defaultPlaceRequest = new PlaceRequest(defaultPlaceNameToken);
		this.loginPopupPresenter = loginPopupPresenter;
		
		eventBus.addHandler(showMainPage.TYPE, new showMainPage.showMainHandler() {
			
			@Override
			public void onshowMain(showMainPage event) {
				// TODO Auto-generated method stub
				revealDefaultPlace();
			}
		});
	}

	@Override
	public void revealDefaultPlace() {
		revealPlace(defaultPlaceRequest, false);
	}
	
	@Override
	public void revealUnauthorizedPlace(String unauthorizedHistoryToken) {
		// If not authorized, show login dialog
		RevealRootPopupContentEvent.fire(this, loginPopupPresenter);
	}
}
