package se.festivitas.gwtptest.client.presenter;

import se.festivitas.gwtptest.client.GlobalGatekeeper;
import se.festivitas.gwtptest.client.events.showMainPage;

import com.gwtplatform.mvp.client.PresenterWidget;
import com.gwtplatform.mvp.client.PopupView;
import com.google.inject.Inject;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.event.shared.EventBus;

public class LoginPopupPresenter extends
		PresenterWidget<LoginPopupPresenter.MyView> {

	public interface MyView extends PopupView {
		HasClickHandlers getLoginButton();
	}

	@Inject
	public LoginPopupPresenter(final EventBus eventBus, final MyView view) {
		super(eventBus, view);
	}

	@Override
	protected void onBind() {
		super.onBind();
		
		/*
		 * Handler for login button click
		 */
		registerHandler(getView().getLoginButton().addClickHandler(
				new ClickHandler() {

					@Override
					public void onClick(ClickEvent event) {
						GlobalGatekeeper.canLogin = true;

						// Hide the login box
						getView().hide();

						// Show the main page
						fireEvent(new showMainPage());
					}
				}
			)
		);
	}
}
